-- Create pgstatspack schema tables.	
--
-- By frits.hoogland@interaccess.nl
-- Based on Glenn.Fawcett@Sun.com's snap procedure
--

DROP TABLE pgstatspack_snap;
CREATE TABLE pgstatspack_snap
(
snapid bigint,
ts     timestamp,
description   varchar(255)
);

DROP TABLE pgstatspack_database;
CREATE TABLE pgstatspack_database 
(
  snapid bigint,  
  datid	oid,
  datname varchar(50),
  numbackends int,
  xact_commit bigint,
  xact_rollback bigint,
  blks_read bigint,
  blks_hit bigint
);

DROP TABLE pgstatspack_tables;
CREATE TABLE pgstatspack_tables 
(
  snapid bigint,  
  table_name varchar(50),
  seq_scan bigint,
  seq_tup_read bigint,
  idx_scan bigint,
  idx_tup_fetch bigint,
  n_tup_ins bigint,
  n_tup_upd bigint,
  n_tup_del bigint,
  heap_blks_read bigint,
  heap_blks_hit bigint,
  idx_blks_read bigint,
  idx_blks_hit bigint,
  toast_blks_read bigint,
  toast_blks_hit bigint,
  tidx_blks_read bigint,
  tidx_blks_hit bigint
);

DROP TABLE pgstatspack_indexes;
CREATE TABLE pgstatspack_indexes 
(
  snapid bigint,  
  index_name varchar(50),
  table_name varchar(50),
  idx_scan bigint,
  idx_tup_read bigint,
  idx_tup_fetch bigint,
  idx_blks_read bigint,
  idx_blks_hit bigint
);

DROP TABLE pgstatspack_sequences;
CREATE TABLE pgstatspack_sequences
(
  snapid bigint,
  sequence_schema varchar(50),
  sequence_name varchar(50),
  seq_blks_read bigint,
  seq_blks_hit bigint
);

DROP TABLE pgstatspack_settings;
CREATE TABLE pgstatspack_settings
(
  snapid bigint,
  name text,
  setting text,
  source text
);

DROP SEQUENCE pgstatspackid;
CREATE SEQUENCE pgstatspackid;

